
#include <ctype.h>
#include <unistd.h>

#include "globdef.h"
#include "fontdef.h"
#include "keyboard_def.h"
#include "vernr.h"

int timf2_sampling_speed;
int swfloat;
int no_of_rx_channels;
double passband_center;
double old_passband_center;
char *error_exit_msg;
int kill_all_flag;
int os_flag;
int lir_inkey;
int screen_width;
int screen_height;
int screen_totpix;
int screen_last_line;
int screen_last_xpixel;
int screen_last_col;
int text_width;
int text_height;

FILE *dmp;
int lir_errcod;


char *press_any_key={"Press any key"};
char *press_enter={"Press ENTER"};
char *out_of_memory="Out of memory";
char netrec_rx_multi_group[]={"239.255.0.00"};

char *uiparm_text[MAX_UIPARM]={"vga mode",          //0
                               "font scale",        //1
                               "Screen width (%)",  //2
                               "Screen height (%)", //3
                               "Netaddr offset",    //4
                               "Base port",         //5
                               "Max scrfiles",      //6
                               "Max lines"};        //7

USERINT_PARM ui;
char *userint_filename="par_ui";

NET_RX_STRUCT net_rxdata_fft2;

void fq_scale(int x1, int x2, int y, int j, double fq_valstep, 
             double fq_value, double fq_x, double fq_xstep)
{
int k;
int xa,xb,xc,xd,ya,yb;
char s[80];
double t1;
xb=-1;
ya=y+text_height-1;
yb=y+text_height+2;
hide_mouse(x1 ,x2, y+1, y+text_height+3);
lir_fillbox(x1+2, y+1, x2-x1-4,text_height+2,0);
xd=fq_x;
while( xd < x2)
  {
  if(fq_value >=100000)fq_value-=100000;
  sprintf(s,"%.1f",fq_value);
  k=0;
  while(s[k]!=0)k++;
  xc=fq_x-k*text_width/2;
  xd=xc+k*text_width+2;
  if(xc > x1+2 && xd < x2)
    {
    lir_pixwrite(xc, y+2,s);
    if(xb > 0)
      {
      if(j <= 2 )
        {
        xa=(fq_x+xb)/2;
        lir_line(xa,ya,xa,yb,14);
        if(kill_all_flag) return;
        }
      else
        {  
        t1=0.2*(fq_x-xb)+0.5;
        xa=t1;
        lir_line(xb+xa,ya,xb+xa,yb,15);
        if(kill_all_flag) return;
        lir_line(fq_x-xa,ya,fq_x-xa,yb,15);
        if(kill_all_flag) return;
        t1=0.4*(fq_x-xb)+0.5;
        xa=t1;
        lir_line(xb+xa,ya,xb+xa,yb,15);
        if(kill_all_flag) return;
        lir_line(fq_x-xa,ya,fq_x-xa,yb,15);
        if(kill_all_flag) return;
        }
      }
    xb=fq_x;  
    lir_line(fq_x,ya,fq_x,yb,15);
    if(kill_all_flag) return;
    lir_line(fq_x+1,ya,fq_x+1,yb,15);
    if(kill_all_flag) return;
    lir_line(fq_x-1,ya,fq_x-1,yb,15);
    if(kill_all_flag) return;
    }
  fq_x+=fq_xstep;
  fq_value+=fq_valstep;
  }    
}



void toupper_await_keyboard(void)
{
await_keyboard();
lir_inkey=toupper(lir_inkey);
}

void clear_keyboard(void)
{
test_keyboard();
if(kill_all_flag) return;
while(lir_inkey != 0)
  {
  test_keyboard();
  if(kill_all_flag) return;
  }
}

void lir_text(int x, int y, char *txt)
{
char s[512];
int i,j;
if(x<0 || y<0 || y > screen_last_line)return;
i=0;
while(txt[i] != 0)i++;
if(x+i <= screen_last_col)
  {
  lir_pixwrite(x*text_width, y*text_height+1,txt);
  }
else 
  {
  j=1+screen_last_col-x;
  if(j > 0)
    {
    for(i=0; i<j; i++)s[i]=txt[i];
    s[j]=0;
    lir_pixwrite(x*text_width, y*text_height,s);
    }
  }  
}

void lir_pixwrite(int x0, int y, char *txt)
{
int i, x;
unsigned int k;
i=-1;
if(x0>=0)
  {
  if(y>=0)
    {
    if(y+text_height-font_ysep < screen_height)
      {
      i=0;
      x=x0;
      while(txt[i] != 0)
        {
        k=(unsigned char)(txt[i]);
        if(k>160)k=1;
        if(x+text_width > screen_width)goto errx;
        lir_putbox(x,y,font_w,font_h,&vga_font[k*font_size]);
        i++;
        x+=text_width;
        } 
      return;
      }
    }
  }      
errx:;  
DEB"pixwrite ERROR");
DEB"\n[%s]   x=%d(%d)    y=%d(%d)",txt,x0,screen_width,y,screen_height);
}

int lir_get_integer(int  x, int y, int len, int min, int max)
{
char s[16];
int i, j, pos;
if(len < 1 || len > 15)len=3;
for(i=1; i<len; i++)s[i]=' '; 
s[0]='_';
s[len]=0;
lir_text(x,y,s);
pos=0;
digin:;
await_keyboard();
if(kill_all_flag)return min;
switch (lir_inkey)
  {
  case F1_KEY:
  return min;

  case 10: 
  if(pos != 0)
    {
    j=atoi(s);
    s[pos]=' ';
    if(j < min)
      {
      j=min;
      sprintf(s,"%d ",min);
      }
    lir_text(x,y,s);
    return j;
    }
  break;

  case 8:
  case 127:
  case ARROW_LEFT_KEY:
  if(pos > 0)
    {
    s[pos+1]=0;
    s[pos]=' ';
    pos--;
    s[pos]='_';
    lir_text(x,y,s);
    s[pos+1]=0;
    }
  break;
  
  default:
  if(lir_inkey>='0' && lir_inkey <='9')
    {
    if(pos < len)
      {
      s[pos]=lir_inkey;
      pos++;
      s[pos]=0;
      j=atoi(s);
      if(j > max)sprintf(s,"%d",max);
      pos=0;
      while(s[pos] != 0 && s[pos] != ' ')pos++;
      s[pos]='_';
      j=pos+1;
      while( j< len)
        {
        s[j]=' ';
        j++;
        }
      s[len]=0;    
      lir_text(x,y,s);
      s[pos+1]=0;
      }
    }
  break;
  }
goto digin;
}

void clear_lines(int i, int j)
{
int k;
if(i > j)
  {
  k=i;
  i=j;
  j=k;
  }
lir_fillbox(0,i*text_height,screen_width-1,(j-i+1)*text_height,0);
}

void *chk_free(void *p)
{
if(p==NULL)return NULL;
free(p);
return NULL;
}

void parfile_end(FILE *file)
{
fprintf(file,"\nChange only between brackets.");
fprintf(file,"\nIf file has errors, Zoom will ignore file and prompt");
fprintf(file,"\nfor a complete set of new parameters\n");
fprintf(file,"\n%s",PROGRAM_NAME);
fclose(file);
}

char * save_uiparm(void)
{
char *errms;
FILE *file;
int *uiparm;
int i;
uiparm=(void*)(&ui);
file = fopen(userint_filename, "w");
errms=(void*)font8x12;
if (file == NULL)
  {
  sprintf(errms,"failed to create %s",userint_filename);
  return errms;
  }
for(i=0; i<MAX_UIPARM; i++)
  {
  fprintf(file,"%s [%d]\n",uiparm_text[i],uiparm[i]);
  }
parfile_end(file);
return NULL;
}

int qnqcnt=0;
int qnqcnt1=0;
int qnqcnt2=0;
#define QQLINE 0
void qq(char *s)
{
char w[80];
sprintf(w,"%s%3d",s,qnqcnt);
lir_text(5,QQLINE,w);
lir_refresh_screen();
qnqcnt++;
if(qnqcnt > 999)qnqcnt=0;
}

void qq1(char *s)
{
char w[80];
sprintf(w,"%s%3d",s,qnqcnt1);
lir_text(15,QQLINE,w);
lir_refresh_screen();
qnqcnt1++;
if(qnqcnt1 > 999)qnqcnt1=0;
}

void qq2(char *s)
{
char w[80];
sprintf(w,"%s%3d",s,qnqcnt2);
lir_text(25,QQLINE,w);
lir_refresh_screen();
qnqcnt2++;
if(qnqcnt2 > 999)qnqcnt=0;
}

int adjust_scale(double *step)
{
int pot,i;
double t1;
// Make step the nearest larger of 1, 2 or 5 in the same power of 10 
t1=step[0];
pot=0;
while(t1 > 10)
  {
  t1/=10;
  pot++;
  }
if(t1<0.00001)t1=.00001;  
while(t1 < 1)
  {
  t1*=10;
  pot--;
  }
if(t1 <= 2)
  {
  t1=2;
  i=2;
  goto asx;
  }
if(t1 <= 5)
  {
  t1=5;
  i=5;
  goto asx;
  }
t1=10;
i=1;
asx:;
while(pot > 0)
  {
  t1*=10;
  pot--;
  }
while(pot < 0)
  {
  t1/=10;
  pot++;
  }
step[0]=t1;
return i;
}

int make_power_of_two( int *i)
{
int k;
k=-1;
i[0]+=i[0]-1;
while(i[0] != 0)
  {
  i[0]/=2;
  k++;
  }
i[0]=1<<k;
return k;
}
