
// Always include stdio.h, math.h and stdlib.h
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

typedef void (*ROUTINE) (void);

#define THRFLAG_NOT_ACTIVE 0
#define THRFLAG_INIT 1
#define THRFLAG_ACTIVE 2
#define THRFLAG_IDLE 4
#define THRFLAG_RESET 5
#define THRFLAG_SEM_WAIT 7
#define THRFLAG_AWAIT_INPUT 10
#define THRFLAG_RETURNED 12
#define THRFLAG_KILL -1

#define TRUE 1
#define FALSE 0
#define PERMDEB fprintf(dmp,
#define DEB if(dmp != NULL)PERMDEB
#define BIG 300000000000000000000000000000000000000.
#define GRAPH_RIGHTPRESSED 128

#define OS_FLAG_LINUX 1
#define OS_FLAG_WINDOWS 2
#define OS_FLAG_X 4

// *******************************************
// Structure for user interface parameters selected by operator
typedef struct {
int vga_mode;            //0
int font_scale;          //1
int screen_width_factor; //2
int screen_height_factor;//3
int netaddr_offset;      //4
int base_port;           //5
int max_filesiz;         //6
int max_lines;           //7
}USERINT_PARM;           
extern USERINT_PARM ui;


#define MAX_UIPARM 8
extern char *uiparm_text[MAX_UIPARM];
extern char *userint_filename;

// Structure for multicasting receive data on the network.
#define NET_MULTICAST_PAYLOAD 1392 // This number must be a multiple of 12
typedef struct {

double passband_center;        //  8
int time;                      //  4
float userx_freq;              //  4
int ptr;                       //  4
unsigned short int block_no;   //  2
char userx_no;                 //  1
char passband_direction;       //  1
char buf[NET_MULTICAST_PAYLOAD];
} NET_RX_STRUCT;
extern NET_RX_STRUCT net_rxdata_fft2;
extern char netrec_rx_multi_group[];

typedef struct {
float total;
float lin0;
float lin30;
float lin60;
float circ;
}TWOCHAN_POWER;

extern int timf2_sampling_speed;
extern int swfloat;
extern int no_of_rx_channels;
extern double passband_center;
extern double old_passband_center;
extern int screen_width;
extern int screen_height;
extern int screen_totpix;
extern int screen_last_line;
extern int screen_last_xpixel;
extern int screen_last_col;
extern int text_width;
extern int text_height;
extern FILE *dmp;

extern char *press_any_key;
extern char *press_enter;

extern int kill_all_flag;
extern char *error_exit_msg;
extern char *out_of_memory;
extern int os_flag;
extern int lir_inkey;

void fatal_error(char *errmsg);
void toupper_await_keyboard(void);
void clear_keyboard(void);
void await_keyboard(void);
void test_keyboard(void);
void lir_text(int x, int y, char *txt);
char * init_font(int font_type);
void *chk_free(void *p);
void test_keyboard(void);
int x_global_uiparms(int wn);
void lir_text(int x, int y, char *txt);
void await_keyboard(void);
int lir_get_integer(int  x, int y, int len, int min, int max);
void clear_lines(int i, int j);
void lir_fillbox(int x, int y,int w, int h, unsigned char c);
void xz(char *s);
void test_keyboard(void);
void lir_refresh_screen(void);
void clear_screen(void);
void lir_pixwrite(int x0, int y, char *txt);
void lir_putbox(int x, int y, int w, int h, void* dp);
void lir_hline(int x1, int y, int x2, unsigned char c);
void lir_line(int x1, int yy1, int x2,int y2, unsigned char c);
void lir_setpixel(int x, int y, unsigned char c);
void lir_move_mouse_cursor(void);
void settextcolor(unsigned char color);
void set_button_coordinates(void);
void lir_setpixel(int x, int y, unsigned char c);
char * save_uiparm(void);
void lir_sched_yield(void);
void lir_sleep(int us);
double current_time(void);
void qq(char *s);
void qq1(char *s);
void qq2(char *s);
void hide_mouse(int x1,int x2,int iy1,int y2);
int adjust_scale(double *step);
void fq_scale(int x1, int x2, int y, int j, double fq_valstep, 
                               double fq_value, double fq_x, double fq_xstep);
void thread_rx_fft2_netinput(void);
int make_power_of_two( int *i);



