


#include <stdio.h>
#include <unistd.h>
#include "globdef.h"
#include "vernr.h"
#include "mousedef.h"
#include "keyboard_def.h"
#include "fontdef.h"
#include "uilim.h"

#include <windows.h>
#include <winsock.h>
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

typedef DWORD WINAPI  (*WIN_ROUTINE) (PVOID arg);
DWORD WINAPI winthread_mouse(PVOID arg);
DWORD WINAPI winthread_zoom(PVOID arg);
DWORD WINAPI winthread_kill_all(PVOID arg);

HANDLE thread_handle_kill_all;
HANDLE thread_handle_fft2_netinput;
HANDLE thread_handle_kill_all;
HANDLE thread_handle_zoom;
HANDLE thread_handle_mouse;

DWORD thread_id_kill_all;
DWORD thread_id_zoom;
DWORD thread_id_main_menu;
DWORD thread_id_mouse;
DWORD thread_id_fft2_netinput;

HANDLE sem_kill_all;
HANDLE sem_keyboard;
HANDLE sem_mouse;

char mouse_thread_flag;
char *errms;
int shift_key_status;
double internal_clock_frequency;
LONG internal_clock_offset;

RECT desktop_screen;
HWND linrad_hwnd;
HDC screen_hdc;
HDC memory_hdc;
HANDLE thread_handle_main_menu;
HBITMAP memory_hbm;
BITMAP memory_bm;
unsigned char *mempix;
int first_mempix;
int last_mempix;


#define NUMBER_HOME       36
#define NUMBER_UP         38
#define NUMBER_PGUP       33
#define NUMBER_LEFT       37
#define NUMBER_RIGHT      39
#define NUMBER_END        35
#define NUMBER_DOWN       40
#define NUMBER_PGDN       34
#define NUMBER_INSERT     45
#define NUMBER_DELETE     46
#define FUNCTION_F1		  112
#define FUNCTION_F2		  113
#define FUNCTION_F3		  114
#define FUNCTION_F4		  115
#define FUNCTION_F5		  116
#define FUNCTION_F6		  117
#define FUNCTION_F7		  118
#define FUNCTION_F8		  119
#define FUNCTION_F9		  120
#define FUNCTION_F11		  122
#define FUNCTION_F12		  123
#define FUNCTION_SHIFT             16

char *failed_thread="Failed to create thread";
int toupper(int chr);
void ui_setup(void);
void lir_remove_mouse_thread(void);
void store_in_kbdbuf(int c);
void zoom(void);
void lir_move_mouse_cursor(void);


extern unsigned int netfd_fft2in;



int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
LARGE_INTEGER lrgi;
long old;
int i, j, ws, hs;
static char szAppName[] = PROGRAM_NAME;
MSG msg;
WNDCLASSEX wndclass;
LPBITMAPINFO lpbi;
LPBYTE m_pBits;
char *phony;
if(DUMPFILE)
  {
  dmp = fopen("dmp", "w");
  DEB"\n******************************\n");
  fflush(dmp);
  }
else
  {  
  dmp=NULL;
  }
first_mempix=0x7fffffff;
last_mempix=0;
phony=(void*)hPrevInstance;
phony=(void*)szCmdLine;
os_flag=OS_FLAG_WINDOWS;
ui_setup();
shift_key_status=0;
keyboard_buffer_ptr=0;
keyboard_buffer_used=0;
keyboard_buffer=malloc(KEYBOARD_BUFFER_SIZE*sizeof(int));
GetWindowRect(GetDesktopWindow(), &desktop_screen);
wndclass.cbSize        = sizeof (wndclass);
wndclass.style         = CS_HREDRAW | CS_VREDRAW;
wndclass.lpfnWndProc   = WndProc;
wndclass.cbClsExtra    = 0;
wndclass.cbWndExtra    = 0;
wndclass.hInstance     = hInstance;
wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
wndclass.hCursor       = LoadCursor (NULL, IDC_CROSS);
wndclass.hbrBackground = (HBRUSH) GetStockObject (BLACK_BRUSH);
wndclass.lpszMenuName  = NULL;
wndclass.lpszClassName = szAppName;
wndclass.hIconSm       = LoadIcon (NULL, IDI_APPLICATION);
RegisterClassEx (&wndclass);
ws=desktop_screen.right-desktop_screen.left;
screen_width=(ui.screen_width_factor*ws/100)&-4;
hs=desktop_screen.bottom-desktop_screen.top;
screen_height=ui.screen_height_factor*hs/100;
screen_totpix=screen_width*(screen_height+1);
// Make the size a bit too large. The proper width and height
// to set here is true size plus frame widths.
linrad_hwnd = CreateWindow (szAppName, PROGRAM_NAME,
                     WS_OVERLAPPEDWINDOW,
                     0,0,
                     screen_width+0.05*ws, 
                     screen_height+0.05*hs,
                     NULL, NULL, hInstance, NULL);
ShowWindow (linrad_hwnd, iCmdShow);
UpdateWindow (linrad_hwnd);
screen_hdc=GetDC(linrad_hwnd);
// *****************************************************************
// Set the variables Linrad uses to access the screen.
error_exit_msg=init_font(ui.font_scale);
if(error_exit_msg != NULL)goto wmain_error;
// ******************************************************************
// Rearrange the palette. It was designed for svgalib under Linux
for(i=0;i<3*256;i++)
  {
  svga_palette[i]<<=2;
  }
for(i=0;i<3*256;i+=3)
  {
  j=svga_palette[i];
  svga_palette[i]=svga_palette[i+2];
  svga_palette[i+2]=j;
  }
// ***************************************************************
// Create a BITMAP in our own memory space. The SetPixel function
// of WinAPI os hopelessly slow.  
lpbi = malloc(sizeof(BITMAPINFOHEADER) + (256 * sizeof(RGBQUAD)));
lpbi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
lpbi->bmiHeader.biWidth = screen_width;
lpbi->bmiHeader.biHeight = screen_height+1;
lpbi->bmiHeader.biPlanes = 1;
lpbi->bmiHeader.biBitCount = 8;
lpbi->bmiHeader.biCompression = BI_RGB;
lpbi->bmiHeader.biSizeImage = 0;
lpbi->bmiHeader.biXPelsPerMeter = 0;
lpbi->bmiHeader.biYPelsPerMeter = 0;
lpbi->bmiHeader.biClrUsed = 0;
lpbi->bmiHeader.biClrImportant = 0;
for (i=0; i<255; i++)
  {
  lpbi->bmiColors[i].rgbRed=svga_palette[3*i];
  lpbi->bmiColors[i].rgbGreen=svga_palette[3*i+1];
  lpbi->bmiColors[i].rgbBlue=svga_palette[3*i+2];
  lpbi->bmiColors[i].rgbReserved=0;
  }
memory_hbm= CreateDIBSection(screen_hdc, lpbi, DIB_RGB_COLORS, 
                                (LPVOID *)&m_pBits, NULL, 0 );
free(lpbi);
// ****************************************************************
// Initiate our timer
if(QueryPerformanceFrequency(&lrgi)==0)
  {
  fatal_error("QueryPerformanceFrequency not supported");
  goto wmain_error;
  }
internal_clock_frequency=
     (double)(0x10000)*(double)(0x10000)*lrgi.HighPart+lrgi.LowPart;
if(QueryPerformanceCounter(&lrgi)==0)
  {
  fatal_error("QueryPerformanceFrequency returns an error");
  goto wmain_error;
  }
internal_clock_offset=lrgi.HighPart;
// Create a device context for the memory bitmap.
memory_hdc=CreateCompatibleDC(screen_hdc);
SelectObject(memory_hdc, memory_hbm);
sem_kill_all=CreateSemaphore( NULL, 0, 1024, NULL);
thread_handle_kill_all = CreateThread(NULL, 0, winthread_kill_all, 
                                      (PVOID)phony,0, &thread_id_kill_all);
if(thread_handle_kill_all == NULL)
  {
  error_exit_msg=failed_thread;
  goto wmain_error;
  }
GetObject(memory_hbm,sizeof(memory_bm),&memory_bm);
if(memory_bm.bmType != 0)
  {
  error_exit_msg="GetObject(... failed";
  goto wmain_error;
  }
mempix=memory_bm.bmBits;
// Create a thread for the main menu.
sem_keyboard=CreateSemaphore( NULL, 0, 1024, NULL);
if(kill_all_flag) goto wmain_error;
thread_handle_zoom = CreateThread(NULL, 0, winthread_zoom, 
                                      (PVOID)phony,0, &thread_id_zoom);
if(thread_handle_zoom == NULL)
  {
  error_exit_msg=failed_thread;
  goto wmain_error;
  }
sem_mouse=CreateSemaphore( NULL, 0, 1024, NULL);
thread_handle_mouse = CreateThread(NULL, 0, winthread_mouse, 
                                      (PVOID)phony,0, &thread_id_mouse);
if(thread_handle_mouse == NULL)
  {
  error_exit_msg=failed_thread;
  goto wmain_error;
  }
while (GetMessage (&msg, NULL, 0, 0))
  {
  TranslateMessage (&msg);
  DispatchMessage (&msg);
  }
if(mouse_thread_flag == THRFLAG_NOT_ACTIVE)return 0;
mouse_thread_flag=THRFLAG_KILL;
while(mouse_thread_flag != THRFLAG_RETURNED)
  {
  ReleaseSemaphore(sem_mouse,1,&old);
  lir_sleep(1000);
  }
WaitForSingleObject(thread_handle_mouse,INFINITE);
wmain_error:;
ReleaseDC (linrad_hwnd, screen_hdc);
if(dmp!=NULL)fclose(dmp);
if(error_exit_msg != NULL)printf("\n%s",error_exit_msg);
return 0;
}


double current_time(void)
{
LARGE_INTEGER lrgi;
double dt1;
if(QueryPerformanceCounter(&lrgi)==0)
  {
  fatal_error("Timer error");
  return 0;
  }
dt1=lrgi.HighPart-internal_clock_offset;
dt1*=(float)(0x10000)*(float)(0x10000);
dt1+=lrgi.LowPart;
dt1/=internal_clock_frequency;
return dt1;
}



LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
double dt1;
int cc;
long old;
HDC hdc;
PAINTSTRUCT  ps;
int keydown_type;
switch (iMsg)
  {
  case WM_CREATE:
// We could initiate things here rather than in the main program (???).
  return 0;

  case WM_SIZE:
  first_mempix=0;
  last_mempix=screen_totpix-1;
  break;

  case WM_PAINT:
  hdc=BeginPaint (linrad_hwnd, &ps);
  BitBlt(hdc, 0, 0, screen_width, screen_height, memory_hdc, 0, 0, SRCCOPY);
  EndPaint (linrad_hwnd, &ps);
  return 0;
  

  case WM_CHAR:
  if(wParam==27 || kill_all_flag)
    {
    ReleaseSemaphore(sem_kill_all,1,&old);
    while(!kill_all_flag) lir_sleep(3000);
    store_in_kbdbuf(0);
    dt1=current_time();
    if( current_time()-dt1  < 0.99)
      {
      WaitForSingleObject(&thread_id_kill_all,INFINITE);
      }
    PostQuitMessage(0);
    return 0;
    }
  store_in_kbdbuf(wParam);
  break;

  case WM_KEYUP:
  keydown_type=(lParam>>31)&1;
  if(keydown_type == 1 && wParam==FUNCTION_SHIFT)shift_key_status=0;
  break;
  
  case WM_KEYDOWN:
  keydown_type=lParam>>24;
  cc=0;
  if((keydown_type&1)!=0)
    {
    switch(wParam)
      {
      case NUMBER_HOME: 
      cc=HOME_KEY;
      break;

      case NUMBER_UP: 
      cc=ARROW_UP_KEY;
      break;
      
      case NUMBER_PGUP: 
      cc=PAGE_UP_KEY;
      break;

      case NUMBER_LEFT: 
      cc=ARROW_LEFT_KEY;
      break;

      case NUMBER_RIGHT: 
      cc=ARROW_RIGHT_KEY;
      break;

      case NUMBER_END:
      cc=END_KEY;
      break;

      case NUMBER_DOWN: 
      cc=ARROW_DOWN_KEY;
      break;

      case NUMBER_PGDN: 
      cc=PAGE_DOWN_KEY;
      break;

      case NUMBER_INSERT: 
      cc=INSERT_KEY;
      break;

      case NUMBER_DELETE:
      cc=DELETE_KEY;
      break;

      }
    }  
  else
    {
    if((keydown_type&32)==0)
      {
      if(wParam == FUNCTION_SHIFT)
        {
        shift_key_status=1;
        return 0;
        }        
      if(wParam >=96 && wParam <=105)return 0;
      switch(wParam)
        {
        case NUMERIC_0:
        cc='0';
        break;

        case NUMERIC_1:
        cc='1';
        break;

        case NUMERIC_2:
        cc='2';
        break;

        case NUMERIC_3:
        cc='3';
        break;

        case NUMERIC_4:
        cc='4';
        break;

        case NUMERIC_5:
        cc='5';
        break;

        case NUMERIC_6:
        cc='6';
        break;

        case NUMERIC_7:
        cc='7';
        break;

        case NUMERIC_8:
        cc='8';
        break;

        case NUMERIC_9:
        cc='9';
        break;
        }
      if(shift_key_status == 0)
        {
        switch(wParam)
          {
          case FUNCTION_F1:
          cc=F1_KEY;
          break;

          case FUNCTION_F2:
          cc=F2_KEY;
          break;

          case FUNCTION_F3:
          cc=F3_KEY;
          break;
      
          case FUNCTION_F4:
          cc=F4_KEY;
          break;

          case FUNCTION_F5:
          cc=F5_KEY;
          break;

          case FUNCTION_F6:
          cc=F6_KEY;
          break;

          case FUNCTION_F7:
          cc=F7_KEY;
          break;

          case FUNCTION_F8:
          cc=F8_KEY;
          break;

          case FUNCTION_F9:
          cc=F9_KEY;
          break;

          case FUNCTION_F11:
          cc=F11_KEY;
          break;

          case FUNCTION_F12:
          cc=F12_KEY;
          break;
          }
        }  
      else
        {
        switch(wParam)
          {
          case FUNCTION_F1:
          cc=SHIFT_F1_KEY;
          break;

          case FUNCTION_F2:
          cc=SHIFT_F2_KEY;
          break;
 
          case FUNCTION_F3:
          cc=SHIFT_F3_KEY;
          break;
      
          case FUNCTION_F4:
          cc=SHIFT_F4_KEY;
          break;

          case FUNCTION_F5:
          cc=SHIFT_F5_KEY;
          break;
  
          case FUNCTION_F6:
          cc=SHIFT_F6_KEY;
          break;

          case FUNCTION_F7:
          cc=SHIFT_F7_KEY;
          break;

          case FUNCTION_F8:
          cc=SHIFT_F8_KEY;
          break;
          }
        }
      }
    }
  if(cc != 0)store_in_kbdbuf(cc);
  break;   

  case WM_LBUTTONDOWN:
  new_lbutton_state=1;
  goto mousepost;

  case WM_LBUTTONUP:
  new_lbutton_state=0;
  goto mousepost;

  case WM_RBUTTONDOWN:
  new_rbutton_state=1;
  goto mousepost;

  case WM_RBUTTONUP :
  new_rbutton_state=0;
  goto mousepost;

  case WM_MOUSEMOVE:
  new_mouse_x= LOWORD (lParam);
  new_mouse_y= HIWORD (lParam);
  if(new_mouse_x >= screen_width)new_mouse_x=screen_width-1;
  if(new_mouse_y >= screen_height)new_mouse_y=screen_height-1;
mousepost:;
  ReleaseSemaphore(sem_mouse,1,&old);
  break;

  case WM_DESTROY:
  PostQuitMessage(0);
  return 0;
  }
return DefWindowProc (hwnd, iMsg, wParam, lParam);
}

int win_global_uiparms(int wn)
{
char s[80],ss[10];
int line;
line=2;
if(ui.vga_mode==0)
  {
  ui.vga_mode=10;
  if(screen_width > 640)ui.vga_mode=11;
  if(screen_width > 800)ui.vga_mode=12;
  }
//  ********************  FONT SIZE  ************************
sprintf(s,"Enter font scale (1 to 5)"); 
fntc:;
if(wn==0)
  {
  printf("\n%s, then press Enter: ",s); 
  fgets(ss,8,stdin);
  lir_inkey=toupper(ss[0]);
  ui.font_scale=lir_inkey-'0';
  }
else
  {
  clear_screen();
  lir_text(0,line,s);
  ui.font_scale=lir_get_integer(21,line,2,1,5);
  if(kill_all_flag)return FALSE;
  line++;
  }
if(lir_inkey < '1' || lir_inkey > '5')goto fntc;
// ******************** SCREEN WIDTH ************************  
sprintf(s,"Percentage of screen width to use(%d to %d):",
                                       MIN_SCREEN_W, MAX_SCREEN_W); 
wfac:;
if(wn==0)
  {
  printf("\n%s\n=>",s); 
  fgets(ss,8,stdin);
  sscanf(ss,"%d", &ui.screen_width_factor);
  if(ui.screen_width_factor < MIN_SCREEN_W ||
     ui.screen_width_factor > MAX_SCREEN_W)goto wfac;

  }
else
  {
  clear_lines(line,line);
  lir_text(0,line,s);
  ui.screen_width_factor=lir_get_integer(47,line,3,
                                            MIN_SCREEN_W,MAX_SCREEN_W);
  if(kill_all_flag) return FALSE;
  line++;
  }
// ******************** BASE PORT ************************  
sprintf(s,"Network base port (%d to %d) =>",
                                  NET_MULTI_MINPORT, NET_MULTI_MAXPORT);
basepo:;
if(wn==0)
  {
  printf("\n%s\n=>",s); 
  fgets(ss,8,stdin);
  sscanf(ss,"%d", &ui.base_port);
  if(ui.base_port < NET_MULTI_MINPORT  ||
     ui.base_port > NET_MULTI_MAXPORT)goto basepo;
  }
else
  {
  clear_lines(line,line);
  lir_text(0,line,s);
  ui.base_port=lir_get_integer(47,line,5,
                                 NET_MULTI_MINPORT, NET_MULTI_MAXPORT);
  if(kill_all_flag) return FALSE;
  line++;
  }
// ******************** GROUP LAST BYTE ************************  
sprintf(s,"[%s] New last byte (0 to 15)", netrec_rx_multi_group);
addr:;
if(wn==0)
  {
  printf("\n%s\n=>",s); 
  fgets(ss,8,stdin);
  sscanf(ss,"%d", &ui.netaddr_offset);
  if(ui.netaddr_offset < 0 || ui.netaddr_offset > 15)goto addr;  
  }
else
  {
  clear_lines(line,line);
  lir_text(0,line,s);
  ui.netaddr_offset=lir_get_integer(60,line,2,0,15);
  if(kill_all_flag) return FALSE;
  line++;
  }
// ********************** SCREEN HEIGHT *********************** 
sprintf(s,"Percentage of screen height to use (%d to %d):",
                                            MIN_SCREEN_H, MAX_SCREEN_H); 
hfac:;
if(wn==0)
  {
  printf("\n%s\n=>",s); 
  fgets(ss,8,stdin);
  sscanf(ss,"%d", &ui.screen_height_factor);
  if(ui.screen_height_factor < MIN_SCREEN_H ||
     ui.screen_height_factor > MAX_SCREEN_H)goto hfac;
  }
else
  {
  clear_lines(line,line);
  lir_text(0,line,s);
  ui.screen_height_factor=lir_get_integer(49,line,3,MIN_SCREEN_H,MAX_SCREEN_H);
  if(kill_all_flag) return FALSE;
  line++;
  }
// ********************** SCRATCH FILE SIZE ********************  
sprintf(s,"Max scratch file size in powers of two(%d to %d):",
                                                  MIN_FILESIZ, MAX_FILESIZ);
filemax:;
if(wn==0)
  {
  printf("\n%s\n=>",s); 
  fgets(ss,8,stdin);
  sscanf(ss,"%d", &ui.max_filesiz);
  if(ui.max_filesiz < MIN_FILESIZ || ui.max_filesiz > MAX_FILESIZ)goto filemax;
  }
else
  {
  clear_lines(line,line);
  lir_text(0,line,s);
  ui.max_filesiz=lir_get_integer(49,line,3,MIN_FILESIZ,MAX_FILESIZ);
  if(kill_all_flag) return FALSE;
  line++;
  }
// ********************** WATERFALL LINES LIMITATION *************  
sprintf(s,"Waterfall lines limitation (50 and above)):");
linemax:;
if(wn==0)
  {
  printf("\n%s\n=>",s); 
  fgets(ss,8,stdin);
  sscanf(ss,"%d", &ui.max_lines);
  if(ui.max_lines < 50)goto linemax;
  }
else
  {
  clear_lines(line,line);
  lir_text(0,line,s);
  ui.max_lines=lir_get_integer(49,line,4,50,10000);
  if(kill_all_flag) return FALSE;
  }
// ******************************************************
errms=save_uiparm();
if(errms != NULL)
  {
  if(wn==0)
    {
    printf("\%s",errms);
    }
  else
    {
    lir_text(0,8,errms);
    lir_text(15,9,press_any_key);
    await_keyboard();
    }
  return FALSE;
  }    
return TRUE;
}



void ui_setup(void)
{
FILE *file;
int i, j, k, nread;
char s[10];
char chr;
int *uiparm;
char *parinfo;
uiparm=(int*)(&ui);
parinfo=NULL;
file = fopen(userint_filename, "rb");
if (file == NULL)
  {
  printf("\nSetup file %s missing.",userint_filename);
full_setup:;
  for(i=0; i<MAX_UIPARM; i++) uiparm[i]=0;
  printf("\nUse W to create a new %s file after setup.",userint_filename);
  printf("\n\nPress S for setup routines");
  printf("\nAny other key to exit."); 
  printf("\nThen press enter\n\n=>"); 
  fgets(s,8,stdin);
  chr=toupper(s[0]);
  if(chr != 'S') exit(0);
  if(win_global_uiparms(0) == FALSE)exit(0);
  }
else
  {
  if(parinfo==NULL)
    {
    parinfo=malloc(4096);
    if(parinfo==NULL)exit(0);
    }
  for(i=0; i<4096; i++) parinfo[i]=0;
  nread=fread(parinfo,1,4095,file);
  fclose(file);
  file=NULL;
  if(nread >= 4095)
    {
    goto full_setup;
    }
  k=0;
  for(i=0; i<MAX_UIPARM; i++)
    {
    while(parinfo[k]==' ' ||
          parinfo[k]== '\n' )
      {
      k++;
      if(k>=nread-1)goto full_setup;
      }
    j=0;
    while(parinfo[k]== uiparm_text[i][j] && k<nread)
      {
      k++;
      j++;
      } 
    if(uiparm_text[i][j] != 0)goto full_setup;
    while(parinfo[k]!='[' && k<4096)k++;
    sscanf(&parinfo[k],"[%d]",&uiparm[i]);
    while(parinfo[k]!='\n')k++;
    }
  free(parinfo);
  if(ui.font_scale < 1 || ui.font_scale >5)
    {
    printf("\nIllegal paramerer value in setup file %s",userint_filename);
    goto full_setup;
    }
  if(ui.screen_width_factor < MIN_SCREEN_W || 
     ui.screen_width_factor > MAX_SCREEN_W ||
     ui.screen_height_factor < MIN_SCREEN_H || 
     ui.screen_height_factor > MAX_SCREEN_H)
    {
    printf("\nIllegal screen scale factors.");
    goto full_setup;
    }
  if(ui.max_filesiz < MIN_FILESIZ || ui.max_filesiz > MAX_FILESIZ)
    {
    printf("\nIllegal value for max scratch file size");
    goto full_setup;
    }
  if(ui.base_port < NET_MULTI_MINPORT || ui.base_port > NET_MULTI_MAXPORT)
    {
    printf("\nBase port out of range");    
    goto full_setup;
    }
  if(ui.base_port!=(ui.base_port/10)*10)
    {
    printf("\nIllegal base port. Must be a multiple of 10.");
    goto full_setup;
    }
  if(ui.netaddr_offset <0 || ui.netaddr_offset > 15)
    {
    printf("\nNet address offset out of range");
    goto full_setup;
    }  
  if(ui.max_lines < 50)
    {
    printf("\nMax lines too low");
    goto full_setup;
    }  
  }
errms=save_uiparm();
if(errms != NULL)
  {
  printf("\n%s",errms);
  exit(0);
  }
}

void store_in_kbdbuf(int c)
{
long old;
if(c==13)c=10;
keyboard_buffer[keyboard_buffer_ptr]=c;
keyboard_buffer_ptr=(keyboard_buffer_ptr+1)&(KEYBOARD_BUFFER_SIZE-1);
ReleaseSemaphore(sem_keyboard,1,&old);
}

void aw_keyb(void)
{
while(keyboard_buffer_ptr == keyboard_buffer_used)
  {
  if(keyboard_buffer_ptr == keyboard_buffer_used)
    {
    WaitForSingleObject(sem_keyboard,INFINITE);
    if(kill_all_flag) return;
    }
  }
lir_inkey = keyboard_buffer[keyboard_buffer_used];
keyboard_buffer_used=(keyboard_buffer_used+1)&(KEYBOARD_BUFFER_SIZE-1);
}


void await_keyboard(void)
{
lir_refresh_screen();
aw_keyb();
}

void xz(char *s)
{
if(dmp == NULL) return;
PERMDEB" %s\n",s);
fflush(dmp);
}


void lir_sched_yield(void)
{
Sleep(0);
};

void lir_sleep(int us)
{
Sleep(us/1000);
}

void fatal_error(char *errmsg)
{
long old;
char *ms;
ms=NULL;
if(kill_all_flag) return;
ms=(void*)font8x12;
sprintf(ms,"FATAL ERROR:[%s]",errmsg);
DEB"\n%s",ms);
if(dmp != 0)fflush(dmp);
error_exit_msg=ms;
ReleaseSemaphore(sem_kill_all,1,&old);
lir_sleep(100000);
}

void test_keyboard(void)
{
if(kill_all_flag!=0)return;
if(keyboard_buffer_ptr != keyboard_buffer_used)
  {
  WaitForSingleObject(sem_keyboard,INFINITE);
  lir_inkey = keyboard_buffer[keyboard_buffer_used];
  keyboard_buffer_used=(keyboard_buffer_used+1)&(KEYBOARD_BUFFER_SIZE-1);
  }
else
  {
  lir_inkey=0;  
  }
}

void lir_hline(int x1, int y, int x2, unsigned char c)
{
int i, ia, ib;
ia=(screen_height-y)*screen_width;
if(x1 <= x2)
  {
  ib=ia+x2;
  ia+=x1;
  }
else
  {
  ib=ia+x1;
  ia+=x2;
  }
if(ia < 0 || ib >= screen_totpix)
  {
  fatal_error("lir_hline outside screen");
  return;
  }
for(i=ia; i<=ib; i++)mempix[i]=c;
if(first_mempix > ia)first_mempix=ia;
if(last_mempix < ib)last_mempix=ib;
}

void lir_refresh_screen(void)
{
int l1, l2;
RECT rct;
if(last_mempix >= first_mempix)
  {
  l1=screen_height-last_mempix/screen_width;
  l2=screen_height-first_mempix/screen_width+1;
  first_mempix=0x7fffffff;
  last_mempix=0;
  rct.left=0;
  rct.top=l1;
  rct.right=screen_width;
  rct.bottom=l2;
  RedrawWindow (linrad_hwnd,&rct,NULL,RDW_UPDATENOW);
  InvalidateRect (linrad_hwnd, &rct, FALSE);
  }
}

void lir_line(int x1, int yy1, int x2,int y2, unsigned char c)
{
int ia;
int i,j,k;
int xd, yd;
float t1,t2,delt;
xd=x2-x1;
yd=y2-yy1;
if(yd==0)
  {
  if(xd==0)
    {
    lir_setpixel(x1,yy1,c);
    }
  else
    {
    lir_hline(x1,yy1,x2,c);
    }
  return;  
  }  
if(abs(xd)>=abs(yd))
  {
  if(xd>=0)
    {
    k=1;
    }
  else
    {
    k=-1;
    }  
  if(yd >= 0)
    {
    delt=0.5;
    }
  else
    {  
    delt=-0.5;
    }
  t1=yy1;
  t2=(float)(yd)/abs(xd);
  i=x1-k;
  while(i!=x2)
    {
    i+=k;
    j=t1+delt;
    ia=i+(screen_height-j)*(screen_width);
    if(ia < 0 || ia >= screen_totpix)
      {
      fatal_error("lir_line outside screen");
      return;
      }
    mempix[ia]=c;
    if(first_mempix > ia)first_mempix=ia;
    if(last_mempix < ia)last_mempix=ia;
    t1+=t2;
    }
  }  
else
  {
  if(yd>=0)
    {
    k=1;
    }
  else
    {
    k=-1;
    } 
  if(xd >= 0)
    {
    delt=0.5;
    }
  else
    {  
    delt=-0.5;
    }
  t1=x1;
  t2=(float)(xd)/abs(yd);
  i=yy1-k;
  while(i!=y2)
    {
    i+=k;
    j=t1+delt;
    ia=j+(screen_height-i)*(screen_width);
    if(ia < 0 || ia >= screen_totpix)
      {
      fatal_error("lir_line outside screen");
      return;
      }
    mempix[ia]=c;
    if(first_mempix > ia)first_mempix=ia;
    if(last_mempix < ia)last_mempix=ia;
    t1+=t2;
    }
  }  
}

void lir_move_mouse_cursor(void)
{
set_button_coordinates();
// We do not have a cursor of our own. Do nothing.
}

DWORD WINAPI winthread_mouse(PVOID arg)
{
char *c;
c=arg;
mouse_thread_flag=THRFLAG_ACTIVE;
while(mouse_thread_flag==THRFLAG_ACTIVE)
  {
// **********************************************
// Wait until a mouse event occurs. 
  WaitForSingleObject(sem_mouse,INFINITE);
  lir_move_mouse_cursor();
  check_mouse_actions();
  }
mouse_thread_flag=THRFLAG_RETURNED;  
return 100;
}

void lir_setpixel(int x, int y, unsigned char c)
{
int ia;
ia=x+(screen_height-y)*screen_width;
if(ia < 0 || ia >= screen_totpix)fatal_error("setpixel outside screen");
mempix[ia]=c;
if(first_mempix > ia)first_mempix=ia;
if(last_mempix < ia)last_mempix=ia;
}

void lir_putbox(int x, int y, int w, int h, void* dp)
{
unsigned char *savmem;
int i, j, k, m;
k=x+(screen_height-y)*screen_width;
if(k-h*screen_width<0 || k+w > screen_totpix)
  {
  fatal_error("putbox outside screen");
  return;
  }
if(last_mempix < k+h-1)last_mempix=k+h-1;
m=0;
savmem=(unsigned char*)dp;
for(j=0; j<h; j++)
  {
  for(i=0; i<w; i++)
    {
    mempix[k+i]=savmem[m];
    m++;
    }
  k-=screen_width;
  }
k+=screen_width;
if(first_mempix > k)first_mempix=k;
}

void lir_fillbox(int x, int y,int w, int h, unsigned char c)
{
int i, j, k;
k=x+(screen_height-y)*screen_width;
if(k-h*screen_width<0 || k+w > screen_totpix)
  {
  fatal_error("fillbox outside screen");
  return;
  }
if(last_mempix < k+h-1)last_mempix=k+h-1;
for(j=0; j<h; j++)
  {
  for(i=0; i<=w; i++)mempix[k+i]=c;
  k-=screen_width;
  }
k+=screen_width;
if(first_mempix > k)first_mempix=k;
}

void clear_screen(void)
{
BitBlt(memory_hdc, 0, 0, screen_width, screen_height, NULL, 0, 0, BLACKNESS);
first_mempix=0;
last_mempix=screen_totpix;
lir_refresh_screen();
}

void show_mouse(void)
{
// Do nothing, Windows or X11 take care of the mouse cursor
}

DWORD WINAPI winthread_zoom(PVOID arg)
{
char *c;
c=arg;
netfd_fft2in=0x80000000;
zoom();
if(netfd_fft2in != 0x80000000)close(netfd_fft2in);
return 100;
}

DWORD WINAPI winthread_fft2_netinput(PVOID arg)
{
char *c;
c=arg;
SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST);
thread_rx_fft2_netinput();
return 100;
}

void create_netrec_fft2_thread(void)
{
char *phony;
phony=NULL;
thread_handle_fft2_netinput = CreateThread(NULL, 0, 
           winthread_fft2_netinput, (PVOID)phony,0, &thread_id_fft2_netinput);
if(thread_handle_fft2_netinput == NULL)fatal_error(failed_thread);
}

void wait_for_netrec_exit(void)
{
WaitForSingleObject(thread_handle_fft2_netinput,INFINITE);
WSACleanup();
}

DWORD WINAPI winthread_kill_all(PVOID arg)
{
// Wait until the semaphore is released.
// Then stop all processing threads so main can write any
// error message and exit.
char *c;
c=arg;
WaitForSingleObject(sem_kill_all,INFINITE);
clear_screen();
if(error_exit_msg != NULL)
  {
  lir_text(0,0,error_exit_msg);
  lir_text(0,2,"Press any key");
  lir_refresh_screen();
  }
kill_all_flag=TRUE;
return 100;
}

void hide_mouse(int x1, int x2, int iy1, int y2)
{
int i;
i=x1|x2|iy1|y2;
// Do nothing, Windows or X11 take care of the mouse cursor
}
